/*
** ComponentBuilderOrbix.h
*/

#ifndef COMPONENTBUILDER_H_
#define COMPONENTBUILDER_H_
#define ICOMPONENT_NAME "IComponent"
#define IRECEPTACLES_NAME "IReceptacles"
#define IMETAINTERFACE_NAME "IMetaInterface"

#include <string>
#include <list>
#include <omg/orb.hh>
#include <omg/PortableServer.hh>
#include <ComponentContextOrbix.h>
#include <ExtendedFacetDescription.h>
#include <IComponentOrbix.h>
//#include <IReceptacleOrbix.h>
#include <IMetaInterfaceOrbix.h>

#ifdef VERBOSE
  #include "verbose.h"
#endif

namespace scs {
  namespace core {
    class ComponentContext;
    class IComponentImpl;

    class ComponentBuilder {
      private:
        CORBA::ORB* orb;
        PortableServer::POA* poa;
      public:
      #ifdef VERBOSE
        static Verbose* verbose;
      #endif
        ComponentBuilder(
          CORBA::ORB* _orb, 
          PortableServer::POA* _poa);
        ~ComponentBuilder();
        ComponentContext* newComponent(
          std::list<ExtendedFacetDescription>& facetExtDescs, 
          ComponentId& id, std::list<PortableServer::ServantBase*>* facetInstances = NULL,
          ComponentContext* context = NULL);
        void addFacet(
          ComponentContext& context, 
          ExtendedFacetDescription& extDesc,
          PortableServer::ServantBase* instance = NULL);
        void addFacets(
          ComponentContext& context, 
          std::list<ExtendedFacetDescription>& facetExtDescs,
          std::list<PortableServer::ServantBase*>& facetInstances);
        CORBA::ORB* getORB();
        PortableServer::POA* getPOA();
    };
  }
}

#endif

