/*
** IMetaInterfaceImpl.h
*/

#ifndef IMETAINTERFACEIMPL_H_
#define IMETAINTERFACEIMPL_H_

#include <map>
#include <ComponentContextOrbix.h>

#include <stubs/scsS.hh>

#ifdef VERBOSE
  #include "verbose.h"
#endif

namespace scs {
  namespace core {
    class IMetaInterfaceImpl : virtual public POA_scs::core::IMetaInterface {
    private:
      ComponentContext* context;
      std::map<std::string, FacetDescription>* facets;
    public:
      IMetaInterfaceImpl(ComponentContext* context);
    #ifdef VERBOSE
      static Verbose* verbose;
    #endif
      static void* instantiate(ComponentContext* context);
      static void destruct(void* obj);
      ~IMetaInterfaceImpl();

      FacetDescriptions* getFacets() IT_THROW_DECL((CORBA::SystemException));
      FacetDescriptions* getFacetsByName(const NameList&  names)
        IT_THROW_DECL((CORBA::SystemException, InvalidName));
      ReceptacleDescriptions* getReceptacles()
        IT_THROW_DECL((CORBA::SystemException));
      ReceptacleDescriptions* getReceptaclesByName(const NameList &  names)
        IT_THROW_DECL((CORBA::SystemException, InvalidName));
    };
  }
}


#endif /* IMETAINTERFACEIMPL_H_ */
